using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.SqlServer.Management.Smo;
using Microsoft.SqlServer.Management.Common;

using SqlWebAdmin.CSharp;

public partial class DeleteStoredProcedure : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            txtDatabaseName.Text = HttpUtility.HtmlEncode(Request.QueryString["database"]);
            lblStoredProcedureName.Text = HttpUtility.HtmlEncode(Request.QueryString["storedprocedure"]);
        }
    }

    protected void cmdNo_Click(object sender, EventArgs e)
    {
        Response.Redirect("StoredProcedures.aspx?database=" + HttpUtility.UrlEncode(Request.QueryString["database"]), false);
    }

    protected void cmdYes_Click(object sender, EventArgs e)
    {
			lblError.Visible = false;

			Server smoServer = SmoHelper.GetServer();
            try
            {
                

                string databaseName = Request.QueryString["database"];
                Database smoDatabase = smoServer.Databases[databaseName];
                if (smoDatabase != null)
                {

                    string storedProcedureName = Request.QueryString["storedprocedure"];
                    StoredProcedure smoStoredProcedure = smoDatabase.StoredProcedures[storedProcedureName];
                    if (smoStoredProcedure != null)
                    {
                        smoStoredProcedure.Drop();

                        Response.Redirect("StoredProcedures.aspx?database=" + HttpUtility.UrlEncode(Request.QueryString["database"]), false);
                    }
                    else
                    {
                        Response.Redirect(String.Format("error.aspx?error={0}", Globals.storedProcedureNotFoundErrorNumber), false);
                    }

                }
                else
                {
                    Response.Redirect(String.Format("error.aspx?error={0}", Globals.databaseNotFoundErrorNumber), false);
                }
            }
            catch (SmoException smoEx)
            {
                lblError.Text = HttpUtility.HtmlEncode(Common.ConcatenateExceptions(smoEx));
                lblError.Visible = true;
            }
            catch (System.Exception ex)
            {
                lblError.Text = HttpUtility.HtmlEncode(Common.ConcatenateExceptions(ex));
                lblError.Visible = true;
			}
			finally
			{
				smoServer.ConnectionContext.Disconnect();
			}

           
    }

}
