<%@ Application Language="C#" %>
<%@ Import Namespace="SqlWebAdmin.CSharp" %>
<script runat="server">


        
    void Application_Start(Object sender, EventArgs e) {
        // Register the SiteMapResolve event handler
        SiteMap.Provider.SiteMapResolve += new SiteMapResolveEventHandler(Common.ExpandPath);
    }

    void Application_End(Object sender, EventArgs e) {
        //  Code that runs on application shutdown

    }
        
    void Application_Error(Object sender, EventArgs e) { 
        // Code that runs when an unhandled error occurs

    }

    void Session_Start(Object sender, EventArgs e) {
        // Code that runs when a new session is started

    }

    void Session_End(Object sender, EventArgs e) {
        // Code that runs when a session ends. 
        // Note: The Session_End event is raised only when the sessionstate mode
        // is set to InProc in the Web.config file. If session mode is set to StateServer 
        // or SQLServer, the event is not raised.
        

    }

    protected void Application_BeginRequest(object sender, EventArgs e)
    {

    }

    protected void Application_PostAcquireRequestState(object sender, EventArgs e)
    {
        // check if it's a page request, if it is, then we need to check if the use has a session
        // and the page request is not for the default.aspx (the default.aspx page is the only page
        // that we don't enforce a session for). If it's not default and the user doesn't have a 
        // session established, then redirect to the home page
        
    }

    protected void Profile_MigrateAnonymous(object sender, ProfileMigrateEventArgs pe)
    {
        //Get the anonymous profile here
        ProfileCommon anonProfile = Profile.GetProfile(pe.AnonymousID);

        //pick up the anonymous value if available
        if (!String.IsNullOrEmpty(anonProfile.ConnectionString))
        {
            //carry over the desired properties;
            Profile.ConnectionString = anonProfile.ConnectionString;
        }

        if (!String.IsNullOrEmpty(anonProfile.InitializationVector))
            Profile.InitializationVector = anonProfile.InitializationVector;

        //Delete the anonymous data from the database
        ProfileManager.DeleteProfile(pe.AnonymousID);

        //Remove the anonymous identifier from the request so 
        //this event will no longer fire for a logged-in user
        AnonymousIdentificationModule.ClearAnonymousIdentifier();
    }

    void Profile_ProfileAutoSaving(Object sender, ProfileAutoSaveEventArgs e)
    {
        if ((e.Context.Items["CancelProfileAutoSave"] != null) && ((bool)e.Context.Items["CancelProfileAutoSave"] == true))
            e.ContinueWithProfileAutoSave = false;
    }


    
</script>
